; punkoe
; perso.asm - gestion de l'etat et du deplacement du perso

  section ".text"

  xdef GestionPerso

  include "punkoe.h"

; GestionPerso
; Gestion de l'etat et de la position du perso
GestionPerso:
; Deplacement horizontal
  cmpi.w  #i_xperso,c_xperso(a3)
  blt.s   \GestionEtatPerso
    subi.w  #i_xperso,c_xperso(a3)

    lea.l   dirperso(a4),a2
    move.w  (a2),d0
    add.w   d0,(a4) ; xperso
    bpl.s   \PasDebordementGauche
      addq.w  #2,(a4) ; xperso
      neg.w   (a2) ; dirperso
  \PasDebordementGauche:
    cmpi.w  #160-8,(a4) ; xperso
    ble.s   \PasDebordementDroit
      subq.w  #2,(a4) ; xperso
      neg.w   (a2) ; dirperso
  \PasDebordementDroit:

\GestionEtatPerso:
  lea.l   t_vperso(a4),a1
  lea.l   etatperso(a4),a2
  move.w  (a2),d0
  bne.s   \GestionEtatsTombeEtMonte

; Etat COURT
; Changement vers MONTE si un evenement SAUT est present
; Changement vers TOMBE si perso au-dessus du vide

; Test de la presence de l'evenement SAUT
  tst.w   even_saut(a4)
  beq.s   \TesteVide
    clr.w   even_saut(a4)
    addq.w  #MONTE-COURT,(a2) ; Changement vers MONTE
    clr.w   (a3) ; Initialisation du compteur c_vperso
    rts

\TesteVide:
; Teste si le perso est au-dessus du vide
; Ca ne peut etre le cas que s'il n'est pas a cheval sur deux cases
  moveq.l #7,d1
  move.w  (a4),d0 ; xperso
  and.w   d0,d1
  bne.s   \FinGestionPerso

    lsr.w   #4,d0

    move.w  d5,d1 ; hmap
    sub.w   d6,d1 ; hperso
    divu.w  #24,d1
    mulu.w  #10,d1

    add.w   d1,d0

    tst.b   0(a5,d0.w)
    bne.s   \FinGestionPerso
      addq.w  #TOMBE-COURT,(a2)
      move.w  #64,(a1) ; t_vperso
      clr.w   (a3) ; c_vperso

\FinGestionPerso:
      rts

\GestionEtatsTombeEtMonte:
  move.w  (a1),d1 ; t_vperso
  lsr.w   #3,d1
  cmp.w   (a3),d1 ; c_vperso
  bgt.s   \FinGestionPerso
    sub.w   d1,(a3) ; c_vperso

  subq.w  #1,d0
  bne.s   \EtatTombe

; Etat MONTE
; Changement vers TOMBE si t_perso atteint la valeur seuil
  addq.w  #1,d6
  addq.w  #1,(a1) ; t_vperso
  cmpi.w  #64,(a1) ; t_vperso
  blt.s   \FinGestionPerso
    addq.w  #TOMBE-MONTE,(a2) ; Mise  l'tat TOMBE
    rts

\EtatTombe:
; Etat TOMBE
; Changement vers COURT si collision avec une plate-forme
  subq.w  #1,d6
  tst.w   (a1) ; t_vperso
  beq.s   \TestCollision
    subq.w  #1,(a1) ; t_vperso

\TestCollision:
  move.w  d5,d0 ; hmap
  sub.w   d6,d0 ; hperso
  bcs.s   \FinGestionPerso ; si hmap < hperso

  divu.w  #24,d0
  move.l  d0,d1
  swap.w  d1
  tst.w   d1
  bne.s   \FinGestionPerso

  mulu.w  #10,d0
  lea.l   0(a5,d0.w),a0 ; a0 = map[y]

  move.w  (a4),d0 ; xperso
  move.w  d0,d1
  lsr.w   #4,d0
  tst.b   0(a0,d0.w)
  bne.s   \ChangementVersCourt

  add.w   #15,d1
  lsr.w   #4,d1
  tst.b   0(a0,d1.w)
  beq.s   \FinGestionPerso

\ChangementVersCourt:
  subq.w  #-(COURT-TOMBE),(a2) ; changement vers l'etat COURT
  rts
